
//>> URL Declarations
var URL = new Object;
URL.BaG_WebSite = "http://www.Me1.at.ua/";

//>> Settings File
System.Gadget.settingsUI = "Settings.html";

//*************************************************************
//  GADGET >> GEN: Initialize
//  PARAMS >> None
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Init()
{	
	//>> Load Data From File
	UTIL_STOR_Load();
	
	//>> Flyout File
	System.Gadget.Flyout.file = "Flyouts/Flyout-Browser.html";
	
	//>> Retrieve Variables
	var Search_Engine = UTIL_VAR_Read("Search_Engine", "DS");
	var Disabled = UTIL_VAR_Read("Disabled", '');
	var Theme = UTIL_VAR_Read("Theme", "1");
		
	//>> Check For Older Sizes
	var Browser_Size = UTIL_VAR_Read("Browser_Size", "850x540");			
	if (Browser_Size == "850x520")
		Browser_Size = "850x540";
	else if (Browser_Size == "900x570")
		Browser_Size = "900x590";
	else if (Browser_Size == "950x620")
		Browser_Size = "950x640";
	else if (Browser_Size == "1000x670")
		Browser_Size = "1000x690";
	else if (Browser_Size == "1050x720")
		Browser_Size = "1050x740";
		
	UTIL_VAR_Write("Browser_Size", Browser_Size);
		
	//>> Interface Resize
	$B_Width(130);
	$B_Height(90);
	$B_BG("url('Images/Themes/Theme-" + Theme + "-Medium.png') no-repeat");
	
	//>>  Construct UI
	var xString = '';
	
	//>> Section: Top
	xString += '<div id="Sec-Top">';
		xString += '<select id="Sec-Top-Engines" onchange="GADGET_GEN_Switch_Sec();">';
		
		//>> Load Engine File
		UTIL_XML_Load("../Engines/Engines.xml");
		var xFile = XML_Doc.getElementsByTagName("Engines")[0];
		var xFile_Engines = xFile.getElementsByTagName("Engine");
		
		i = 0;
		var Temp = '';
		var Temp_Type = '';
		var Temp_Name = '';
		var Temp_Value = '';
		
		while (i < xFile_Engines.length)
		{
			Temp = xFile_Engines[i];
			Temp_Type = Temp.getAttribute("Type");
			Temp_Name = Temp.getAttribute("Name");
			Temp_Value = Temp.getAttribute("Value");
			
			if (Disabled.indexOf(Temp_Value) <= -1)
			{				
				if (Temp_Type == "Label")
					xString += "<option value='" + Temp_Value + "' class='Sec-Top-Seperator'>" + Temp_Name + "</option>";
				else
					xString += "<option value='" + Temp_Value + "'>" + Temp_Name + "</option>";
			}
			i++;		
		}
		
		if (Disabled.indexOf(Search_Engine) > -1)
		{
			i = 0;
			Search_Engine = '';
			while (i < xFile_Engines.length)
			{
				Temp = xFile_Engines[i];
				Temp_Type = Temp.getAttribute("Type");
				Temp_Value = Temp.getAttribute("Value");
				
				if (Disabled.indexOf(Temp_Value) <= -1 && Temp_Type == "Engine")
				{
					Search_Engine = Temp_Value;
					UTIL_VAR_Write("Search_Engine", Search_Engine);
					break;
				}
				i++;		
			}
		}
			
		xString += '</select>';
		xString += '<div id="Sec-Top-Logo" onclick="GADGET_GEN_Launch();"></div>';
	xString += '</div>';
	
	//>> Section: Bottom
	xString += '<div id="Sec-Bottom"></div>';
	
	if (Search_Engine == '')
	{
		xString = "<span style='line-height: 13px;'><br /><strong>No Engines Enabled</strong><br />&bull; &bull; &bull; &bull; &bull; &bull; &bull;<br />";
		xString += "<span style='font-size: 11px;'>You can activate<br />engines from the<br />settings panel</span></span>";
		$_HTML("Gadget-Content", xString);
	}
	else
	{
		$_HTML("Gadget-Content", xString);
		
		//>> Populate Field
		$("Sec-Top-Engines").value = Search_Engine;
			
		//>> Switch To Appropriate Section
		GADGET_GEN_Switch_Sec();
	}
}

//*************************************************************
//  GADGET >> GEN: Switch Section
//  PARAMS >> None
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Switch_Sec()
{	
	//>> Get & Save Section
	var Search_Engine = $("Sec-Top-Engines").value;
	if (Search_Engine == 'Label_1' || Search_Engine == 'Label_2' || Search_Engine == 'Label_3')
	{
		Search_Engine = UTIL_VAR_Read("Search_Engine", "Google");
		$("Sec-Top-Engines").value = Search_Engine;
	}
	
	UTIL_VAR_Write("Search_Engine", Search_Engine);
	$_Class("Sec-Top-Logo", 'Logo-' + Search_Engine);
	
	var Country = UTIL_VAR_Read("Country", "US");
	var Search_Term = UTIL_VAR_Read("Search_Term", "Search for...");
	
	//>> Load Engine File
	UTIL_XML_Load("../Engines/" + Search_Engine + ".xml");
	var xFile = XML_Doc.getElementsByTagName("Engine")[0];
	
	//>> Get Available Countries
	var Ext = xFile.getElementsByTagName("Ext")[0].text;
	
	if (Ext.indexOf(Country) <= -1)
		Country = "US";
		
	//>> Begin Options Construction
	var Type = xFile.getElementsByTagName("Type")[0].text;
	var Override_View = xFile.getElementsByTagName("Override_View")[0].text;
	var Override_Style = xFile.getElementsByTagName("Override_Style")[0].text;
	var Select_View = '';
	
	if (Override_View != '')
		Select_View = 'onchange="GADGET_GEN_Check_Opt(\'' + Override_View + '\');"';
	
	var xString = '<div id="Sec-Bottom-Options">';
		xString += '<select id="Sec-Bottom-Select" ' + Select_View + '>';
	
	var xFile_Ext = xFile.getElementsByTagName("Ext_" + Country)[0];
	var xFile_Option = xFile_Ext.getElementsByTagName("Option");
	
	i = 0;
	var Temp = '';
	var Temp_Name = '';
	var Temp_Value = '';
	var Temp_Style = '';
	
	if (Override_Style == '')
	{
		while (i < xFile_Option.length)
		{
			Temp = xFile_Option[i];
			Temp_Name = Temp.getAttribute("Name");
			Temp_Value = Temp.getAttribute("Value");		
			xString += "<option value='" + Temp_Value + "'>" + Temp_Name + "</option>";
			i++;		
		}
	}
	else
	{
		while (i < xFile_Option.length)
		{
			Temp = xFile_Option[i];
			Temp_Name = Temp.getAttribute("Name");
			Temp_Value = Temp.getAttribute("Value");
			
			if (Override_Style.indexOf(Temp_Value) > -1)
				Temp_Style = "class='Sec-Bottom-Seperator'";
			else
				Temp_Style = '';
			
			xString += "<option value='" + Temp_Value + "' " + Temp_Style + ">" + Temp_Name + "</option>";
			i++;		
		}
	}
	
	xString += '</select>';
	xString += '</div>';
	xString += '<div id="Sec-Bottom-Change">';
	
	if (Type == "Search")
	{
		xString += '<div id="Sec-Bottom-Field">';
			xString += '<input id="Sec-Bottom-Text" class="Sec-Bottom-Text-Inactive" type="text" value="Search for..." ';
			xString += 'onclick="GADGET_GEN_Text_Click();" onblur="GADGET_GEN_Text_Blur();" onkeyup="GADGET_GEN_Text_Check(event.keyCode);" ondblclick="GADGET_GEN_Text_Erase(this);" />';
		xString += '</div>';
		xString += '<div id="Sec-Bottom-Search" onclick="GADGET_GEN_Gadget_Search();" title="Search"></div>';
	}
	else if (Type == "View")
	{
		xString += '<div id="Sec-Bottom-Read" onclick="GADGET_GEN_Gadget_Search();" title="Read"></div>';
		xString += '<input id="Sec-Bottom-Text" class="Sec-Bottom-Text-Inactive" type="text" value="Search for..." style="display: none;"/>';
	}
	else if (Type == "Watch")
	{
		xString += '<div id="Sec-Bottom-Watch" onclick="GADGET_GEN_Gadget_Search();" title="Watch"></div>';
		xString += '<input id="Sec-Bottom-Text" class="Sec-Bottom-Text-Inactive" type="text" value="Search for..." style="display: none;"/>';
	}
	
	xString += '</div>';
	
	//>> Populate Bottom Section
	$_HTML("Sec-Bottom", xString);
	
	//>> Populate Search Term
	$("Sec-Bottom-Text").value = Search_Term;
	if (Search_Term != '' && Search_Term != "Search for...")
		$_Class("Sec-Bottom-Text", "Sec-Bottom-Text-Active");	
	
	//>> Save Data
	UTIL_STOR_Save();
}

//*************************************************************
//  GADGET >> GEN: Text Field Click
//  PARAMS >> None
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Text_Click()
{	
	if ($("Sec-Bottom-Text").value == "Search for...")
	{
		$("Sec-Bottom-Text").value = '';
		$_Class("Sec-Bottom-Text", "Sec-Bottom-Text-Active");
	}	
}

//*************************************************************
//  GADGET >> GEN: Text Field Blur
//  PARAMS >> None
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Text_Blur()
{	
	if ($("Sec-Bottom-Text").value == '')
	{
		$("Sec-Bottom-Text").value = "Search for...";
		$_Class("Sec-Bottom-Text", "Sec-Bottom-Text-Inactive");
	}	
}

//*************************************************************
//  GADGET >> GEN: Erase Search Term
//  PARAMS >> Field (Object)
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Text_Erase(Field)
{	
	Field.value = '';
	UTIL_VAR_Write("Search_Term", '');
	UTIL_STOR_Save();
}

//*************************************************************
//  GADGET >> GEN: Check Field For Enter
//  PARAMS >> Key (Int)
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Text_Check(Key)
{	
	if (Key == 13)
		GADGET_GEN_Gadget_Search();
	else
		UTIL_VAR_Write("Search_Term", $("Sec-Bottom-Text").value);	
}

//*************************************************************
//  GADGET >> GEN: Launch Site In Browser
//  PARAMS >> None
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Launch()
{
	//>> Get Variables
	var URI = '';
	var Mode = '';
	var Ext_Amz = '';
	var Ext_eB = '';
	var i = 0;
	var Temp = '';
	var Temp_Value = '';
	
	var Country = UTIL_VAR_Read("Country", "US");
	var Enhanced = UTIL_VAR_Read("Enhanced", "Yes");
	var History = UTIL_VAR_Read("History", "Yes");
	var Search_Engine = UTIL_VAR_Read("Search_Engine", "Google");
	var Display = UTIL_VAR_Read("Display", "Flyout");
	var Category = $("Sec-Bottom-Select").value;
	
	var Search_Term = $("Sec-Bottom-Text").value;
	if (Search_Term == "Search for...")
		Search_Term = '';
		
	//>> Save Search Term
	UTIL_VAR_Write("Search_Term", Search_Term);
	
	//>> Check Term For History
	if (Search_Term != '' && History == "Yes")
	{
		var History_Search = UTIL_VAR_Read("History_Search", '');
		if (History_Search.indexOf(Search_Term + "|") == -1 || History_Search == '')
			History_Search = Search_Term + "|" + History_Search;
		
		//>> Reconstruct Search History
		var History_Array = History_Search.split("|");
		History_Search = '';
		var i = 0;
		
		while (i < History_Array.length)
		{
			if (History_Array[i] != '' && i < 10)
				History_Search += History_Array[i] + "|";
			i++;
		}
		UTIL_VAR_Write("History_Search", History_Search);
	}
		
	//>> Load Engine File
	UTIL_XML_Load("../Engines/" + Search_Engine + ".xml");
	var xFile = XML_Doc.getElementsByTagName("Engine")[0];
	
	//>> Get Available Countries
	var Ext = xFile.getElementsByTagName("Ext")[0].text;
	if (Ext.indexOf(Country) <= -1)
		Country = "US";
		
	//>> Prep Search Or View Mode
	if (Search_Term != '' && $("Sec-Bottom-Text").style.display != "none")
		Mode = "Search";
	else
		Mode = "View";
		
	//>> Find Enhanced URLs
	var Enhanced_Engine = xFile.getElementsByTagName("Enhanced")[0].text;
	if (Enhanced_Engine != "No" && Enhanced == "Yes")
	{
		if (Enhanced_Engine == "Override_All")
		{
			URI = xFile.getElementsByTagName("Enhanced_URL")[0].text;
			URI = URL.BaG_Landing + URI;
			
			if (Mode == "Search")
				URI += "?Category=" + Category + "&amp;Search_Term=" + Search_Term + "&amp;Country=" + Country + "&amp;Display=" + Display;
			else
				URI += "?Category=" + Category + "&amp;Country=" + Country + "&amp;Display=" + Display;
			URI += "&amp;" + "Force_Refresh=" + Math.floor(Math.random()*101);
			if (URI.indexOf("&amp;") > -1)
				URI = URI.replace(/&amp;/gi, "&");
		}
		else if (Enhanced_Engine.indexOf(Category) > -1)
		{
			var Enhanced_URLs = xFile.getElementsByTagName("Enhanced_URLs")[0];
			var Enhanced_Opt = Enhanced_URLs.getElementsByTagName("Enhanced_URL");
			
			i = 0;
			while (i < Enhanced_Opt.length)
			{
				Temp = Enhanced_Opt[i];
				Temp_Value = Temp.getAttribute("Value");		
				if (Temp_Value == Category)
				{
					URI = Temp.text;
					URI = URL.BaG_Landing + URI;
					
					if (Mode == "Search")
						URI += "?Category=" + Category + "&amp;Search_Term=" + Search_Term + "&amp;Country=" + Country + "&amp;Display=" + Display;
					else
						URI += "?Category=" + Category + "&amp;Country=" + Country + "&amp;Display=" + Display;
					URI += "&amp;" + "Force_Refresh=" + Math.floor(Math.random()*101);
					if (URI.indexOf("&amp;") > -1)
						URI = URI.replace(/&amp;/gi, "&");
					
					break;
				}
				i++;		
			}
		}
	}
	
	//>> If No Enhanced URL Found Or Available
	if (URI == '')
	{
		var xFile_Ext = xFile.getElementsByTagName("Ext_" + Country)[0];
		var xFile_Option = xFile_Ext.getElementsByTagName("Option");
		var Temp_Search = '';
		var Temp_View = '';
		i = 0;
		while (i < xFile_Option.length)
		{
			Temp = xFile_Option[i];
			Temp_Value = Temp.getAttribute("Value");
			Temp_Search = Temp.getAttribute("Search");
			Temp_View = Temp.getAttribute("View");
			
			if (Temp_Value == Category)
			{
				if (Mode == "Search" && Temp_Search != '')
					URI = Temp_Search;
				else
					URI = Temp_View;
				break;
			}
			i++;		
		}
		
		//>> Replace URL Elements
		if (URI.indexOf("&amp;") > -1)
			URI = URI.replace(/&amp;/gi, "&");
		if (URI.indexOf("[") > -1)
		{
			URI = URI.replace("[Search_Term]", escape(Search_Term));
			if (URI.indexOf("[Refresh]") > -1)
				URI = URI.replace("[Refresh]", "Force_Refresh=" + Math.floor(Math.random()*101));		
		}
		
		//>> Prep Country Extensions For Amazon / eBay
		if (Search_Engine == "Amazon")
			URI = GADGET_GEN_Amz(Country, Ext_Amz, URI);
		else if (Search_Engine == "eBay")
			URI = GADGET_GEN_eBay(Country, Ext_eB, URI);
	}

	UTIL_VAR_Write("URL", URI);
	
	//>> Save Data
	UTIL_STOR_Save();

	URI = URI.replace(/ /gi, "%20");
	Shell.Run(URI);
}

//*************************************************************
//  GADGET >> GEN: Check Options For View Override
//  PARAMS >> Override (String)
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Check_Opt(Override)
{	
	var xString = '';
	var Value = $("Sec-Bottom-Select").value;	
	var Search_Term = UTIL_VAR_Read("Search_Term", "Search for...");
	
	if (Override.indexOf(Value) > -1)
	{
		xString += '<div id="Sec-Bottom-View" onclick="GADGET_GEN_Gadget_Search();" title="View"></div>';
		xString += '<input id="Sec-Bottom-Text" class="Sec-Bottom-Text-Inactive" type="text" value="Search for..." style="display: none;"/>';
	}
	else
	{
		xString += '<div id="Sec-Bottom-Field">';
			xString += '<input id="Sec-Bottom-Text" class="Sec-Bottom-Text-Inactive" type="text" value="Search for..." ';
			xString += 'onclick="GADGET_GEN_Text_Click();" onblur="GADGET_GEN_Text_Blur();" onkeyup="GADGET_GEN_Text_Check(event.keyCode);" ondblclick="GADGET_GEN_Text_Erase(this);" />';
		xString += '</div>';
		xString += '<div id="Sec-Bottom-Search" onclick="GADGET_GEN_Gadget_Search();" title="Search"></div>';
	}
		
	$_HTML("Sec-Bottom-Change", xString);
	
	//>> Populate Search Term
	$("Sec-Bottom-Text").value = Search_Term;
	if (Search_Term != '' && Search_Term != "Search for...")
		$_Class("Sec-Bottom-Text", "Sec-Bottom-Text-Active");	
}

//*************************************************************
//  GADGET >> GEN: Gadget Search
//  PARAMS >> None
//  AUTHOR >> Matthew Gowdy
//  MODDED >> 3.27.2009
//*************************************************************
function GADGET_GEN_Gadget_Search()
{		
	//>> Get Variables
	var URI = '';
	var Mode = '';
	var Ext_Amz = '';
	var Ext_eB = '';
	var i = 0;
	var Temp = '';
	var Temp_Value = '';
	
	var Country = UTIL_VAR_Read("Country", "US");
	var Enhanced = UTIL_VAR_Read("Enhanced", "Yes");
	var History = UTIL_VAR_Read("History", "Yes");
	var Search_Engine = UTIL_VAR_Read("Search_Engine", "Google");
	var Display = UTIL_VAR_Read("Display", "Flyout");
	var Category = $("Sec-Bottom-Select").value;
	
	var Search_Term = $("Sec-Bottom-Text").value;
	if (Search_Term == "Search for...")
		Search_Term = '';
		
	//>> Save Search Term
	UTIL_VAR_Write("Search_Term", Search_Term);
	
	//>> Check Term For History
	if (Search_Term != '' && History == "Yes")
	{
		var History_Search = UTIL_VAR_Read("History_Search", '');
		if (History_Search.indexOf(Search_Term + "|") == -1 || History_Search == '')
			History_Search = Search_Term + "|" + History_Search;
		
		//>> Reconstruct Search History
		var History_Array = History_Search.split("|");
		History_Search = '';
		var i = 0;
		
		while (i < History_Array.length)
		{
			if (History_Array[i] != '' && i < 10)
				History_Search += History_Array[i] + "|";
			i++;
		}
		UTIL_VAR_Write("History_Search", History_Search);
	}
		
	//>> Load Engine File
	UTIL_XML_Load("../Engines/" + Search_Engine + ".xml");
	var xFile = XML_Doc.getElementsByTagName("Engine")[0];
	
	//>> Get Available Countries
	var Ext = xFile.getElementsByTagName("Ext")[0].text;
	if (Ext.indexOf(Country) <= -1)
		Country = "US";
		
	//>> Prep Search Or View Mode
	if (Search_Term != '' && $("Sec-Bottom-Text").style.display != "none")
		Mode = "Search";
	else
		Mode = "View";
		
	//>> Find Enhanced URLs
	var Enhanced_Engine = xFile.getElementsByTagName("Enhanced")[0].text;
	if (Enhanced_Engine != "No" && Enhanced == "Yes")
	{
		if (Enhanced_Engine == "Override_All")
		{
			URI = xFile.getElementsByTagName("Enhanced_URL")[0].text;
			URI = URL.BaG_Landing + URI;
			
			if (Mode == "Search")
				URI += "?Category=" + Category + "&amp;Search_Term=" + Search_Term + "&amp;Country=" + Country + "&amp;Display=" + Display;
			else
				URI += "?Category=" + Category + "&amp;Country=" + Country + "&amp;Display=" + Display;
			URI += "&amp;" + "Force_Refresh=" + Math.floor(Math.random()*101);
			if (URI.indexOf("&amp;") > -1)
				URI = URI.replace(/&amp;/gi, "&");
		}
		else if (Enhanced_Engine.indexOf(Category) > -1)
		{
			var Enhanced_URLs = xFile.getElementsByTagName("Enhanced_URLs")[0];
			var Enhanced_Opt = Enhanced_URLs.getElementsByTagName("Enhanced_URL");
			
			i = 0;
			while (i < Enhanced_Opt.length)
			{
				Temp = Enhanced_Opt[i];
				Temp_Value = Temp.getAttribute("Value");		
				if (Temp_Value == Category)
				{
					URI = Temp.text;
					URI = URL.BaG_Landing + URI;
					
					if (Mode == "Search")
						URI += "?Category=" + Category + "&amp;Search_Term=" + Search_Term + "&amp;Country=" + Country + "&amp;Display=" + Display;
					else
						URI += "?Category=" + Category + "&amp;Country=" + Country + "&amp;Display=" + Display;
					URI += "&amp;" + "Force_Refresh=" + Math.floor(Math.random()*101);
					if (URI.indexOf("&amp;") > -1)
						URI = URI.replace(/&amp;/gi, "&");
					
					break;
				}
				i++;		
			}
		}
	}
	
	//>> If No Enhanced URL Found Or Available
	if (URI == '')
	{
		var xFile_Ext = xFile.getElementsByTagName("Ext_" + Country)[0];
		var xFile_Option = xFile_Ext.getElementsByTagName("Option");
		var Temp_Search = '';
		var Temp_View = '';
		i = 0;
		while (i < xFile_Option.length)
		{
			Temp = xFile_Option[i];
			Temp_Value = Temp.getAttribute("Value");
			Temp_Search = Temp.getAttribute("Search");
			Temp_View = Temp.getAttribute("View");
			
			if (Temp_Value == Category)
			{
				if (Mode == "Search" && Temp_Search != '')
					URI = Temp_Search;
				else
					URI = Temp_View;
				break;
			}
			i++;		
		}
		
		//>> Replace URL Elements
		if (URI.indexOf("&amp;") > -1)
			URI = URI.replace(/&amp;/gi, "&");
		if (URI.indexOf("[") > -1)
		{
			URI = URI.replace("[Search_Term]", escape(Search_Term));
			if (URI.indexOf("[Refresh]") > -1)
				URI = URI.replace("[Refresh]", "Force_Refresh=" + Math.floor(Math.random()*101));		
		}
		
		//>> Prep Country Extensions For Amazon / eBay
		if (Search_Engine == "Amazon")
			URI = GADGET_GEN_Amz(Country, Ext_Amz, URI);
		else if (Search_Engine == "eBay")
			URI = GADGET_GEN_eBay(Country, Ext_eB, URI);
	}

	UTIL_VAR_Write("URL", URI);
	
	//>> Save Data
	UTIL_STOR_Save();

	//>> Select Display Method
	if (Display == "Flyout")
		System.Gadget.Flyout.show = true;
	else
	{
		URI = URI.replace(/ /gi, "%20");
		Shell.Run(URI);
	}
}
